from SmartSection                     import SmartSection
from SmartSectionElement              import SmartSectionElement, manage_addSectionElement
from General                          import findFormContainer
from Products.Formulator              import StandardFields
from HTMLForm                         import HTMLForm

import time, string


def manage_addSmartBoxForm(self, REQUEST):
    ''' '''
    root = findFormContainer(self)
    if not hasattr(root, 'edit_SmartBoxForm'):
        form = HTMLForm('edit_SmartBoxForm', 'Edit Form for Smart Boxs')
        form.manage_changeProperties(addAction  = 'manage_addSmartBox',
                                     editAction = 'manage_edit_properties')

        form._setObject('headerText', StandardFields.StringField(
            "headerText",
            title         = "Header Text",
            required      = 0,
            display_width = 40,
            max_length    = 1000) )

        form._setObject('boxHeight', StandardFields.IntegerField(
            "boxHeight",
            title         = "Height",
            required      = 0,
            start         = 0,
            end           = 1000))

        form._setObject('boxWidth', StandardFields.StringField(
            "boxWidth",
            title         = "Width",
            required      = 0,
            display_width = 5,
            max_length    = 5) )

        root._setObject('edit_SmartBoxForm', form)

    REQUEST.set('mode', 'Add')
    return REQUEST.RESPONSE.redirect(self.absolute_url()+'/'+root.edit_SmartBoxForm.getId()+'/renderMethod?mode=add')
    

def manage_addSmartBox(self, id='', title='', nextURL='', position=0, REQUEST=None):
    ''' '''
    return manage_addSectionElement(self, SmartBox, id, title, nextURL, position, REQUEST)


_renderText = '''
<br>
<table width="%(boxWidth)s" cellspacing="0" cellpadding="0" border="0">
  <tr>
    <td width="%(boxWidth)s" class="boxBorder">
      <table width="100%%" cellspacing="1" cellpadding="3" border="0">
        <tr>
          <th width="100%%" class="boxTitle">
            %(headerText)s
          </th>
        </tr>
        <tr>
          <td width="100%%" class="boxBody">
            <table width="100%%" cellspacing="0" cellpadding="0" border="0">
              <tr>
                <td width="100%%" class="boxBody">
                  %(content)s
                </td>
                <td><img src="transPixel_gif" width="1" height="%(boxHeight)i"></td>
              </tr>
            </table>
          </td>
        </tr>
      </table>
    </td>
  </tr>
</table>
<br>
'''


class SmartBox(SmartSection, SmartSectionElement):
    ''' '''

    meta_type = 'Smart Box'
    icon = 'misc_/SmartSections/HTMLBlock'

    _properties= ( {'id': 'boxHeight',      'type': 'int',    'mode': 'w', 'default': 160          },
                   {'id': 'boxWidth',       'type': 'string', 'mode': 'w', 'default': '350'        },
                   {'id': 'headerText',     'type': 'string', 'mode': 'w', 'default': 'Box Header' } )


    __init__ = SmartSectionElement.__init__

    old_render = SmartSection.render

    renderText = _renderText


    def render(self, mode='view'):
        ''' '''
        dict = self.__dict__
        dict['content'] = self.old_render(mode)
        return self.renderText %dict

