from SmartSectionElement              import SmartSectionElement, manage_addSectionElement
from General                          import findFormContainer
from HTMLForm                         import HTMLForm
from Products.Formulator              import StandardFields
from Products.Formulator.Form         import FormValidationError

import time, string


def manage_addSmartHeaderForm(self, REQUEST):
    ''' '''
    root = findFormContainer(self)
    if not hasattr(root, 'edit_SmartHeaderForm'):
        form = HTMLForm('edit_SmartHeaderForm', 'Edit Form for Smart Headers')
        form.manage_changeProperties(addAction  = 'manage_addSmartHeader',
                                     editAction = 'manage_edit_properties')

        form._setObject('size', StandardFields.ListField(
            'size',
            title='Size',
            default=1,
            size=1,
            items=[('Large',  1), ('Larger',  2),
                   ('Medium', 3), ('Smaller', 4),
                   ('Small',  5), ('Tiny',    6)],
            required=1) )

        form._setObject('text', StandardFields.StringField(
            "text",
            title         = "Text",
            required      = 0,
            display_width = 40,
            max_length    = 1000) )

        form._setObject('cssClass', StandardFields.StringField(
            "cssClass",
            title         = "CSS Class",
            required      = 0,
            display_width = 40,
            max_length    = 1000) )

        root._setObject('edit_SmartHeaderForm', form)

    REQUEST.set('mode', 'Add')
    return REQUEST.RESPONSE.redirect(self.absolute_url()+'/'+root.edit_SmartHeaderForm.getId()+'/renderMethod?mode=add')


def manage_addSmartHeader(self, id='', title='', nextURL='', position=0, REQUEST=None):
    ''' '''
    return manage_addSectionElement(self, SmartHeader, id, title, nextURL, position, REQUEST)


class SmartHeader(SmartSectionElement):
    ''' '''

    meta_type = 'Smart Header'
    icon = 'misc_/SmartSections/Header'

    _properties= ( {'id': 'size',     'type': 'int',    'mode': 'w', 'default': 1       },
                   {'id': 'text',     'type': 'string', 'mode': 'w', 'default': ''      },
                   {'id': 'cssClass', 'type': 'string', 'mode': 'w', 'default': 'header'} )
                   
    renderText = '''<h%(size)s class="%(cssClass)s">%(text)s</h%(size)s>'''





