from HTMLForm                             import HTMLForm
from General                              import findFormContainer
from FolderishSmartSectionElement         import FolderishSmartSectionElement
from Products.OrderedFolder.OrderedFolder import OrderedFolder
from Products.Formulator                  import StandardFields
from Products.Formulator.Form             import FormValidationError

import SmartCell
import time, string


def manage_addSmartRowForm(self, REQUEST):
    ''' '''
    root = findFormContainer(self)
    if not hasattr(root, 'edit_SmartRowForm'):
        form = HTMLForm('edit_SmartRowForm', 'Edit Form for Smart Rows')
        form.manage_changeProperties(addAction  = 'manage_addSmartRow',
                                     editAction = 'manage_edit_properties')

    return REQUEST.RESPONSE.redirect('../../manage_addSmartRow')


def manage_addSmartRow(self, id='', title='', nextURL='', position=1, REQUEST=None, returnId=0):
    ''' '''

    if not id: id  = str(long(time.time()*1000))

    row = SmartRow(id, title)
    self._setObject(id, row, position)

    row = getattr(self, id)

    for headerCell in self.Header.objectValues():
        cell = getattr(row, SmartCell.manage_addSmartCell(row, returnId=1))
        for element in headerCell.objectValues():
            cell.manage_clone(element, element.getId())


    if nextURL:
        REQUEST.RESPONSE.redirect(nextURL)
    elif returnId:
        return id
    elif REQUEST:
        return self.manage_main(self, REQUEST)



class SmartRow(FolderishSmartSectionElement):
    ''' '''

    meta_type = 'Smart Row'

    _meta_types = ({ 'name': 'Smart Cell',
                     'action': 'manage_addProduct/SmartSections/manage_addSmartCellForm'},)


    def getEditHTML(self):
        ''' '''
        return _editHTML


    def render(self, mode='view'):
        ''' '''
        html =    '<tr>\n'
        for object in self.objectValues():
            html = html + object(mode)

        if mode == 'edit':
            html = html + self.getEditHTML()
            
        html = html + '</tr>\n'
        return html

        
_editHTML = '''
<td>
   <a href="%(tableURL)s/manage_addSmartRow?position=%(position)s&nextURL=%(nextURL)s"
      ><img src="misc_/SmartSections/New" border="0" alt="New Row"></a>&nbsp;<a
      href="%(rowURL)s/manage_delete_objects?ids=%(rowId)s&nextURL=%(nextURL)s"
      ><img src="misc_/SmartSections/Delete" border="0" alt="Delete Row"></a> 
</td>
'''
